(*
  DTween

  The MIT License

  Copyright (c) 2011 Lyna, http://twc.xrea.jp/

  Permission is hereby granted, free of charge, to any person obtaining a copy
  of this software and associated documentation files (the "Software"), to deal
  in the Software without restriction, including without limitation the rights
  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  copies of the Software, and to permit persons to whom the Software is
  furnished to do so, subject to the following conditions:

  The above copyright notice and this permission notice shall be included in
  all copies or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
  THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
  THE SOFTWARE.

  ----------

  XV

    Ver.0.1  11/08/09  *

    Ver.0.2  11/08/11  *TTweenSerial, Parallel, Delay

    Ver.0.3  11/08/12  *TTween.Abort
                       *TColor^vpeBɑΉ
                       *eTween\bh̕p[^ł

    Ver.0.4  11/08/13  *Overwrite@\

    Ver.0.5  11/08/14  *Ύw莞From, Tȍȗ̃vpeBl擾
                       uTween\bhR[_v
                       u߂ăgDC[sꂽ_vɎdlύX
                       *Duration1t[̎ԂɖȂgDC[
                        SerialɒǉۂɁAő2̃gDC[sȂ
                        sC
                       *TTweenCycle\bhǉ

    Ver.0.6  11/08/17  *蓮ɂgDC[̍XVɑΉ(AutoUpdatevpeB)
                       *^vpeBɑΉ
                       *TTween.Tween(To,From)\bhŕ̃CX^XxɎw\
                       *TTween.Tween(To,From)\bh̒Pp[^łp~

    Ver.0.7  11/08/18  *gDC[sĂȂƂ
                        ^C}[~߂悤ɂ

    Ver.0.8  11/08/19  *2009ȑÕo[WɑΉ(ꕔ)

    Ver.0.9  11/08/24  *Int64^̃vpeBɑΉ
                       *2006`2009ŃRpCw߂ԈĂ̂C
                       *vpeB̏TypInfoSetXXXXProp֐ɓ

    Ver.0.10 11/09/06  *XE2ɑΉ
                        FireMonkeyAvP[VŎgpꍇ́A
                        vWFNgIvV̏`ɁuFMXAPPvǉĉ
                        (MacOSXiOS̏ꍇ͍̂ƂFireMonkeyȂ̂ŕsvł)

    Ver.0.11 11/09/11  *Platform.GetTick̃oO(QC#98747)
                       *TTweenReverse, Scale, Slice
*)
unit DTween;

interface

{$I DTweenCompilerDefines.inc}

uses
  SysUtils, Classes, TypInfo,
{$IFDEF FPC}
  FMX_Types, FMX_Platform,
{$ELSE}{$IFDEF FMXAPP}
  FMX.Types, FMX.Platform,
  {$IFDEF MSWINDOWS}
  Winapi.MMSystem,
  {$ENDIF}
{$ELSE}{$IFDEF USEUNITSCOPE}
  Winapi.Windows, Vcl.ExtCtrls, Winapi.MMSystem,
{$ELSE}
  Windows, ExtCtrls, MMSystem,
{$ENDIF}{$ENDIF}{$ENDIF}
{$IFDEF USEGENERIC}
  Generics.Collections,
{$ENDIF}
{$IFDEF USERTTI}
  Rtti,
{$ENDIF}
{$IFDEF USENAMESPACE}
  DTween.Easing;
{$ELSE}
  DTweenEasing;
{$ENDIF}

type
  ETweenException = class(Exception);
  ITween = interface;

  { gDC[Cxgp̃\bhQ
    \bhȊÔ(ʂ̃\bh葱)荞߂܂
    2009Õo[Wł̓\bĥݎwł܂ }
{$IFDEF USEANONYMOUSMETHOD}
  TTweenEventProc = reference to procedure(Sender: ITween);
{$ELSE}
  TTweenEventProc = procedure(Sender: ITween) of object;
{$ENDIF}

  { gDC[̓𐧌䂷C^[tF[Xł
    C^[tF[XȂ̂ŁAzQƂɂCtΉ̎Ԃ͂܂ }
  ITween = interface

    { gDC[Đ܂
      ĐI(IsCompleted=True)ōēxĂԂƏčĐ܂ }
    procedure Play;

    { gDC[ꎞ~܂
      PlayōĊJ܂}
    procedure Pause;

    { gDC[~܂ }
    procedure Stop;

    { g̃Rs[Ԃ܂ }
    function Clone: ITween;

    function GetObj: TObject;
    function GetPosition: Double;
    function GetDuration: Double;
    function GetOverwrite: Boolean;
    procedure SetOverwrite(const Value: Boolean);
    function GetStopOnComplete: Boolean;
    procedure SetStopOnComplete(const Value: Boolean);
    function GetIsPaused: Boolean;
    function GetIsCompleted: Boolean;
    function GetOnUpdate: TTweenEventProc;
    procedure SetOnUpdate(const Value: TTweenEventProc);
    function GetOnComplete: TTweenEventProc;
    procedure SetOnComplete(const Value: TTweenEventProc);
    property Obj: TObject read GetObj;

    { ݂̍Đʒu擾܂ }
    property Position: Double read GetPosition;

    { Đ̌pԂ擾܂ }
    property Duration: Double read GetDuration;

    { ɎsĂgDC[̓㏑邩ǂw肵܂
      TruȅꍇAgDC[̑ΏۂƂȂCX^X̃gDC[~܂
      Falsȅꍇ͐ɎsĂgDC[ɑ΂ĉ܂
      Truew肵ۂ̃gDC[̒~Playɍs邽߁A
      łɎs̃gDC[ɑ΂Đݒ肵Ăɔf܂
      ftHglTTween.DefaultOverwritevpeBɈˑ܂ }
    property Overwrite: Boolean read GetOverwrite write SetOverwrite;

    { gDC[̓w肵܂
      TruȅꍇA1xĐ܂
      FalsȅꍇAlɖ߂ČJԂĐ܂
      ftHgTrueł
      SerialDelayŃbvꍇAbvꂽgDC[͎TrueɂȂ܂ }
    property StopOnComplete: Boolean read GetStopOnComplete write SetStopOnComplete;

    { gDC[ꎞ~ĂꍇTrueԂ܂ }
    property IsPaused: Boolean read GetIsPaused;

    { gDC[̓삪ĂꍇTrueԂ܂ }
    property IsCompleted: Boolean read GetIsCompleted;

    { gDC[ŒlXVxɌĂԏw肵܂ }
    property OnUpdate: TTweenEventProc read GetOnUpdate write SetOnUpdate;

    { gDC[ɌĂԏw肵܂
      StopOnCompleteFalsȅꍇA삪xɃR[܂ }
    property OnComplete: TTweenEventProc read GetOnComplete write SetOnComplete;
  end;

{$IFDEF USEGENERIC}
  TTweenList = TList<ITween>;
  TObjectTweenDictionary = class(TObjectDictionary<TObject,TList<ITween>>)
  public
    constructor Create;
  end;
{$ELSE}
  TCollectionNotification = (cnAdded, cnExtracted, cnRemoved);

  TListNotifyEvent = procedure(Sender: TObject; const Item: ITween;
    Action: TCollectionNotification) of object;

  TTweenList = class
  private
    FList: TList;
    FOnNotify: TListNotifyEvent;
    function GetCount: Integer;
    function GetItem(Index: Integer): ITween;
  protected
    procedure Notify(const Item: ITween; Action: TCollectionNotification);
  public
    constructor Create;
    destructor Destroy; override;
    function Add(const Item: ITween): Integer;
    procedure Delete(Index: Integer);
    function Remove(const Item: ITween): Integer;
    function Contains(const Item: ITween): Boolean;

    property Count: Integer read GetCount;
    property Items[Index: Integer]: ITween read GetItem; default;
    property OnNotify: TListNotifyEvent read FOnNotify write FOnNotify;
  end;

  TKeyValue = record
    Key: TObject;
    Value: TTweenList;
  end;
  PKeyValue = ^TKeyValue;

  TObjectTweenDictionary = class
  private
    FList: TList;
    function GetCount: Integer;
    function GetItem(const Key: TObject): TTweenList;
  public
    constructor Create;
    destructor Destroy; override;
    procedure Clear;
    procedure Add(const Key: TObject; const Value: TTweenList);
    procedure Delete(Index: Integer);
    procedure Remove(const Key: TObject);
    function IndexOf(const Item: TObject): Integer;
    function ContainsKey(const Key: TObject): Boolean;
    function TryGetValue(const Key: TObject; out Value: TTweenList): Boolean;
    property Items[const Key: TObject]: TTweenList read GetItem; default;
    property Count: Integer read GetCount;
  end;
{$ENDIF}

  TUpdateProc = {$IFDEF USEANONYMOUSMETHOD}TProc{$ELSE}procedure of object{$ENDIF};

  { gDC[̋N_ƂȂNXł
    CX^XɎg܂(Ă͂Ȃł) }
  TTween = class
  private
{$IFDEF USECLASSPROPERTY}
    const
      DEFAULT_SPEED = 30;
    class var
      FList: TTweenList;
      FObjTweens: TObjectTweenDictionary;
      FTimer: TTimer;
      FPrevTime: Cardinal;
      FDefaultOverwrite: Boolean;
      FAutoUpdate: Boolean;
      FSpeed: Cardinal;
      FOnBeforeUpdate: TUpdateProc;
      FOnAfterUpdate: TUpdateProc;
{$ENDIF}      
    class procedure AddToPlayList(Obj: TObject; Tween: ITween);
    class procedure RemoveFromPlayList(Obj: TObject; Tween: ITween);
    class procedure OnTimer(Sender: TObject);
    class procedure StartTimer;
    class procedure ClearTimer;
    class procedure ListNotify(Sender: TObject; const Item: ITween; Action: TCollectionNotification);
{$IFDEF USECLASSPROPERTY}
    class procedure SetAutoUpdate(const Value: Boolean); {$IFDEF USESTATIC}static;{$ENDIF}
    class procedure SetSpeed(const Value: Cardinal); {$IFDEF USESTATIC}static;{$ENDIF}
{$ENDIF}
  public
    { w肵CX^XɊ֘A铮쒆̃gDC[SĒ~܂
      ȗꍇASĂ̓쒆̃gDC[~܂
      ܂PlayĂȂ́AStopĕʂ̕ϐŕێĂ̓͏܂ }
    class procedure Abort(Obj: TObject = nil);

    { gDC[̍XVs܂
      AutoUpdateTruȅꍇ͎ŌĂяo܂A
      Falsȅꍇ͒IɌĂяoKv܂ }
    class procedure Update;

    { gDC[쐬܂
      ߂lITweenŁAPlay\bhR[ƃgDC[Jn܂
      Obj:
        Ώۂ̃CX^Xw肵܂
      FromValues:
        lύXvpeB̏lw肵܂
        Βlw肵܂AvpeB'$'tꍇ
        gDC[̏s̃vpeBl̑ΒlɂȂ܂
        vpeBƒl݂ɋLq܂
        ex. Tween(Sender, ['$Left', -100, 'Top', 0], [], 500).Play;
      ToValues:
        lύXvpeB̏Ilw肵܂
        Βlw肵܂AvpeB'$'tꍇ
        gDC[̏s̃vpeBl̑ΒlɂȂ܂
        vpeBƒl݂ɋLq܂
        ex. Tween(Sender, [], ['$Left', 100, 'Top', 800], 500).Play;
      Duration:
        FromValuesToValuesɓB鎞Ԃw肵܂
        Pʂ̓~bł
      Easing:
        C[WO֐w肵܂(DTweenjbgTEasing̃\bh)
        ȗꍇATEasing.Lineargp܂ }
    class function Tween(const Obj: TObject; const FromValues, ToValues: array of const;
      const Duration: Cardinal; const Easing: IEasing = nil): ITween; overload;

    { Tween\bh̑ΏۃCX^X𕡐wło[Wł }
    class function Tween(const Objs: array of TObject; const FromValues, ToValues: array of const;
      const Duration: Cardinal; const Easing: IEasing = nil): ITween; overload;

    { Tween\bhFromValuesȗłł
      ̏ꍇFromValues̓gDC[Jn_̒lɂȂ܂ }
    class function TweenTo(Obj: TObject; const ToValues: array of const;
      Duration: Cardinal; const Easing: IEasing = nil): ITween; overload;

    { TweenTȏΏۃCX^X𕡐wło[Wł }
    class function TweenTo(const Objs: array of TObject; const ToValues: array of const;
      Duration: Cardinal; const Easing: IEasing = nil): ITween; overload;

    { Tween\bhToValueȗłł
      ̏ꍇToValue̓gDC[Jn_̒lɂȂ܂ }
    class function TweenFrom(Obj: TObject; const FromValues: array of const;
      Duration: Cardinal; const Easing: IEasing = nil): ITween; overload;

    { TweenFrom̑ΏۃCX^X𕡐wło[Wł }
    class function TweenFrom(const Objs: array of TObject; const FromValues: array of const;
      Duration: Cardinal; const Easing: IEasing = nil): ITween; overload;

    { ̃gDC[𒼗Ɍq܂ }
    class function Serial(const Tweens: array of ITween): ITween; {$IFDEF USESTATIC}static;{$ENDIF}

    { ̃gDC[Ɍq܂ }
    class function Parallel(const Tweens: array of ITween): ITween; {$IFDEF USESTATIC}static;{$ENDIF}

    { w肵gDC[̑OɃfBCt܂ }
    class function Delay(const PreDelay, PostDelay: Cardinal;
      const BaseTween: ITween): ITween; {$IFDEF USESTATIC}static;{$ENDIF}

    { gDC[w񐔌JԂ܂ }
    class function Cycle(const CycleCount: Cardinal;
      const BaseTween: ITween): ITween; {$IFDEF USESTATIC}static;{$ENDIF}

    { gDC[tĐ܂ }
    class function Reverse(const BaseTween: ITween): ITween; {$IFDEF USESTATIC}static;{$ENDIF}

    { gDC[̌pԂXP[܂ }
    class function Scale(const Scale: Double; const BaseTween: ITween): ITween; {$IFDEF USESTATIC}static;{$ENDIF}

    { gDC[ꕔ𒊏o܂
      IsRate=TrueƂꍇ͊JnʒuƏIʒu0.0`1.0̊Ŏw肵܂ }
    class function Slice(const StartPos, EndPos: Double;
      const BaseTween: ITween; const IsRate: Boolean = False): ITween; {$IFDEF USESTATIC}static;{$ENDIF}

    { NXvpeBɑΉĂȂo[Wł͈ȉ̐ݒς܂
      ꉽƂłALq@Ɍ݊Ȃ̂ŔȂƂc }
{$IFDEF USECLASSPROPERTY}
    { egDC[OverwritevpeB̏l`܂
      DefaultOverwriteg̏lTrueł }
    class property DefaultOverwrite: Boolean read FDefaultOverwrite write FDefaultOverwrite;

    { gDC[̍XVTTweens蓮ōsw肵܂
      TruȅꍇATTween^C}[ŎIɍXVs܂(ftHg)
      FalsȅꍇACӂ̃^C~OŃ[U[TTween.UpdateĂяočXV܂ }
    class property AutoUpdate: Boolean read FAutoUpdate write SetAutoUpdate;

    { 1bԂ̍XV񐔂w肵܂
      LȒl1`1000ł(A60𒴂Ƃ܂ӖC܂) }
    class property Speed: Cardinal read FSpeed write SetSpeed;

    { et[ŃgDC[s钼OɌĂ΂Cxgł }
    class property OnBeforeUpdate: TUpdateProc read FOnBeforeUpdate write FOnBeforeUpdate;

    { et[ŃgDC[sꂽɌĂ΂Cxgł }
    class property OnAfterUpdate: TUpdateProc read FOnAfterUpdate write FOnAfterUpdate;
{$ENDIF}
  end;

implementation

uses Math;

function GetTick: Cardinal; {$IFDEF USEINLINE}inline;{$ENDIF}
{$IFDEF MSWINDOWS}
begin
  Result := timeGetTime;
{$ELSE}
var
  H, M, S, MS: word;
begin
  DecodeTime(time, H, M, S, MS);
  Result := ((((H * 60 * 60) + (M * 60) + S) * 1000) + MS);
{$ENDIF}
end;

{$IFDEF USEGENERIC}

{ TObjectTweenDictionary }

constructor TObjectTweenDictionary.Create;
begin
  inherited Create([doOwnsValues]);
end;

{$ELSE}

{ TTweenList }

constructor TTweenList.Create;
begin
  FList := TList.Create;
end;

destructor TTweenList.Destroy;
begin
  while Count > 0 do
    Delete(Count-1);
  FList.Free;
  inherited;
end;

function TTweenList.Add(const Item: ITween): Integer;
begin
  Result := FList.Add(nil);
  ITween(FList.List[Result]) := Item;
  Notify(Item, cnAdded);
end;

procedure TTweenList.Delete(Index: Integer);
var
  temp: ITween;
begin
  temp := ITween(FList[Index]);
  ITween(FList.List[Index]) := nil;
  FList.Delete(Index);
  if temp <> nil then
    Notify(temp, cnRemoved);
end;

function TTweenList.Remove(const Item: ITween): Integer;
begin
  Result := FList.IndexOf(Pointer(Item));
  if Result >= 0 then
  begin
    Delete(Result);
    Notify(Item, cnRemoved);
  end;
end;

function TTweenList.Contains(const Item: ITween): Boolean;
begin
  Result := FList.IndexOf(Pointer(Item)) >= 0;
end;

function TTweenList.GetCount: Integer;
begin
  Result := FList.Count;
end;

function TTweenList.GetItem(Index: Integer): ITween;
begin
  Result := ITween(FList[Index]);
end;

procedure TTweenList.Notify(const Item: ITween; Action: TCollectionNotification);
begin
  if Assigned(FOnNotify) then
    FonNotify(Self, Item, Action);
end;

{ TObjectTweenDictionary }

constructor TObjectTweenDictionary.Create;
begin
  FList := TList.Create;
end;

destructor TObjectTweenDictionary.Destroy;
begin
  Clear;
  FList.Free;
  inherited;
end;

procedure TObjectTweenDictionary.Clear;
begin
  while Count > 0 do
    Delete(Count-1);
  FList.Clear;
end;

procedure TObjectTweenDictionary.Add(const Key: TObject; const Value: TTweenList);
var
  p: PKeyValue;
begin
  New(p);
  p^.Key := Key;
  p^.Value := Value;
  FList.Add(p);
end;

procedure TObjectTweenDictionary.Delete(Index: Integer);
var
  p: PKeyValue;
begin
  p := PKeyValue(FList[Index]);
  p^.Value.Free;
  Dispose(p);
  FList.Delete(Index);
end;

procedure TObjectTweenDictionary.Remove(const Key: TObject);
var
  i: Integer;
begin
  i := IndexOf(Key);
  if i >= 0 then
    Delete(i);
end;

function TObjectTweenDictionary.IndexOf(const Item: TObject): Integer;
begin
  Result := 0;
  while (Result < Count) and (PKeyValue(FList[Result])^.Key <> Item) do
    Inc(Result);
  if Result = Count then
    Result := -1;
end;

function TObjectTweenDictionary.ContainsKey(const Key: TObject): Boolean;
begin
  Result := IndexOf(Key) >= 0;
end;

function TObjectTweenDictionary.TryGetValue(const Key: TObject; out Value: TTweenList): Boolean;
var
  i: Integer;
begin
  i := IndexOf(Key);
  Result := i >= 0;
  if Result then
    Value := PKeyValue(FList[i])^.Value;
end;

function TObjectTweenDictionary.GetCount: Integer;
begin
  Result := FList.Count;
end;

function TObjectTweenDictionary.GetItem(const Key: TObject): TTweenList;
var
  i: Integer;
begin
  i := IndexOf(Key);
  if i >= 0 then
    Result := PKeyValue(FList[i])^.Value
  else
    Result := nil;
end;

{$ENDIF}

{$IFNDEF USECLASSPROPERTY}
const
  DEFAULT_SPEED = 30;
var
  FList: TTweenList;
  FObjTweens: TObjectTweenDictionary;
{$IFDEF USECLASSSYNCHRONIZE}
  FTimerId: MMRESULT;
{$ELSE}
  FTimer: TTimer;
{$ENDIF}
  FPrevTime: Cardinal;
  FDefaultOverwrite: Boolean;
  FAutoUpdate: Boolean;
  FSpeed: Cardinal;
  FOnBeforeUpdate: procedure of object;
  FOnAfterUpdate: procedure of object;
{$ENDIF}

{ TAbstractTween }

type
  TPlayDirection = (pdForward, pdBackward);

  TAbstractTween = class(TInterfacedObject, ITween)
  private
    FDirection: TPlayDirection;
    FParent: TAbstractTween;
    FIsPaused: Boolean;
    FIsCompleted: Boolean;
    FIsInitialized: Boolean;
    FOverwrite: Boolean;
    FStopOnComplete: Boolean;
    FOnUpdate: TTweenEventProc;
    FOnComplete: TTweenEventProc;
    function GetObj: TObject;
    procedure SetParent(const Value: TAbstractTween);
    function GetPosition: Double;
    function GetDuration: Double;
    function GetOverwrite: Boolean;
    procedure SetOverwrite(const Value: Boolean);
    function GetStopOnComplete: Boolean;
    procedure SetStopOnComplete(const Value: Boolean);
    function GetIsPaused: Boolean;
    function GetIsCompleted: Boolean;
    function GetOnUpdate: TTweenEventProc;
    procedure SetOnUpdate(const Value: TTweenEventProc);
    function GetOnComplete: TTweenEventProc;
    procedure SetOnComplete(const Value: TTweenEventProc);
  protected
    FPosition: Double;
    FDuration: Double;
    procedure Initialize; virtual;
    procedure Finalize; virtual;
    procedure DoUpdate; virtual; abstract;
    procedure Update(const APosition: Double);
    procedure CheckCompleted(const APosition: Double);
    procedure DoCompleted;
    procedure AddToPlayList(Tween: ITween); virtual;
    procedure RemoveFromPlayList(Tween: ITween); virtual;
    procedure DoOverwrite; virtual;
    procedure SwitchDirection; virtual;
    property Parent: TAbstractTween read FParent write SetParent;
  public
    constructor Create;
    procedure Play;
    procedure Pause;
    procedure Stop;
    function Clone: ITween; virtual;

    property Position: Double read GetPosition;
    property Duration: Double read GetDuration;
    property Overwrite: Boolean read GetOverwrite write SetOverwrite;
    property StopOnComplete: Boolean read GetStopOnComplete write SetStopOnComplete;
    property IsPaused: Boolean read GetIsPaused;
    property IsCompleted: Boolean read GetIsCompleted;
    property OnComplete: TTweenEventProc read GetOnComplete write SetOnComplete;
  end;

  TPropType = (ptInteger, ptColor, ptFloat, ptInt64);
  TPropValue = record
    case TPropType of
      ptInteger: (AsInteger: Integer);
      ptColor: (AsColor: Integer);
      ptFloat: (AsFloat: Double);
      ptInt64: (AsInt64: Int64);
  end;
  TDiffValue = record
    case TPropType of
      ptInteger: (AsInteger: Integer);
      ptColor: (AsColor: array[0..2] of Integer);
      ptFloat: (AsFloat: Double);
      ptInt64: (AsInt64: Int64);
  end;
  // MEMO: ȂTInitValueTChangeValue̗ŏl邩ƂƁA
  // TInitValueValueTween\bhœnꂽ̂܂܂̏lȂ̂ɑ΂āA
  // TChangeValueBaseValue͌vẐ߂ɃVXeJ[GetSysColor̂ێĂ邽
  // TChangeValue.FinishValue݂闝R
  TInitValue = record
    Prop: PPropInfo;
    IsRelative: Boolean;
    PropType: TPropType;
    Value: TPropValue;
  end;
  TChangeValue = record
    Prop: PPropInfo;
    IsRelative: Boolean;
    BaseValue: TPropValue;
    FinishValue: TPropValue;
    PropType: TPropType;
    DiffValue: TDiffValue;
  end;

  TObjectTween = class(TAbstractTween)
  private
    FObj: TObject;
    FEasing: IEasing;
    FIsValueFixed: Boolean;
    FInitValues: array of TInitValue;
    FChangeValues: array of TChangeValue;

    procedure CalcValues;
    function GetProperty({$IFDEF USERTTI}const RttiType: TRttiType;{$ENDIF}const Obj: TObject; const PropName: string;
      out IsRelative: Boolean; out PropType: TPropType): PPropInfo;
    function GetPropAbsoluteValue(const Obj: TObject; const Prop: PPropInfo;
      const BaseValue: TPropValue): TPropValue;
    procedure ApplyPropValue(const PropType: TPropType; const PropInfo: PPropInfo; const PropValue: TPropValue);
  protected
    procedure Initialize; override;
    procedure Finalize; override;
    procedure DoUpdate; override;
    procedure AddToPlayList(Tween: ITween); override;
    procedure RemoveFromPlayList(Tween: ITween); override;
    procedure DoOverwrite; override;
  public
    constructor Create(const Obj: TObject; const FromValues, ToValues: array of const;
      const Duration: Cardinal; const Easing: IEasing);
    function Clone: ITween; override;
  end;

  // q̃gDC[NX͑Sh
  TWrapTween = class(TAbstractTween)
  private
    function GetBaseTween: ITween; {$IFDEF USEINLINE}inline;{$ENDIF}
  protected
    FTweens: array of ITween;
    procedure AddToPlayList(Tween: ITween); override;
    procedure RemoveFromPlayList(Tween: ITween); override;
    procedure DoOverwrite; override;
    procedure SwitchDirection; override;
  public
    constructor Create(const Tweens: array of ITween); overload;
    constructor Create(const BaseTween: ITween); overload;
    function Clone: ITween; override;
    property BaseTween: ITween read GetBaseTween;
  end;

  TParallelTween = class(TWrapTween)
  protected
    procedure Initialize; override;
    procedure DoUpdate; override;
  public
    constructor Create(const Tweens: array of ITween);
  end;

  TSerialTween = class(TWrapTween)
  private
    FTweenIndex: Integer;
    FDurationOffset: Double;
  protected
    procedure Initialize; override;
    procedure DoUpdate; override;
  public
    constructor Create(const Tweens: array of ITween);
    function Clone: ITween; override;
  end;

  TDelayedTween = class(TWrapTween)
  private
    FPreDelay: Cardinal;
    FPostDelay: Cardinal;
  protected
    procedure DoUpdate; override;
  public
    constructor Create(const PreDelay, PostDelay: Cardinal; const BaseTween: ITween);
    function Clone: ITween; override;
  end;

  TCycledTween = class(TWrapTween)
  private
    FCurrentCount: Cardinal;
    FCycleCount: Cardinal;
  protected
    procedure Initialize; override;
    procedure DoUpdate; override;
  public
    constructor Create(const CycleCount: Cardinal; const BaseTween: ITween);
    function Clone: ITween; override;
  end;

  TReversedTween = class(TWrapTween)
  protected
    procedure Initialize; override;
    procedure DoUpdate; override;
  public
    constructor Create(const BaseTween: ITween);
  end;

  TScaledTween = class(TWrapTween)
  private
    FScale: Double;
  protected
    procedure Initialize; override;
    procedure DoUpdate; override;
  public
    constructor Create(const Scale: Double; const BaseTween: ITween);
    function Clone: ITween; override;
  end;

  TSlicedTween = class(TWrapTween)
  private
    FStartPos: Double;
    FEndPos: Double;
  protected
    procedure Initialize; override;
    procedure DoUpdate; override;
  public
    constructor Create(const StartPos, EndPos: Double; const BaseTween: ITween);
    function Clone: ITween; override;
  end;

constructor TAbstractTween.Create;
begin
  FIsInitialized := False;
  FIsPaused := True;
  FIsCompleted := False;
  FStopOnComplete := True;
{$IFDEF USECLASSPROPERTY}
  FOverwrite := TTween.DefaultOverwrite;
{$ELSE}
  FOverwrite := FDefaultOverwrite;
{$ENDIF}
end;

procedure TAbstractTween.Initialize;
begin
  FIsInitialized := True;
  FIsCompleted := False;
  FPosition := 0;
end;

procedure TAbstractTween.Finalize;
begin
end;

procedure TAbstractTween.CheckCompleted(const APosition: Double);
begin
  if FDirection = pdForward then
  begin
    if APosition >= FDuration then
    begin
      FIsCompleted := True;
      FPosition := FDuration;
      Exit;
    end;
  end
  else if FDirection = pdBackward then
  begin
    if APosition <= 0 then
    begin
      FIsCompleted := True;
      FPosition := 0;
      Exit;
    end;
  end;
  FPosition := APosition;
end;

procedure TAbstractTween.DoCompleted;
begin
  Finalize;
  if Assigned(FOnUpdate) then
    FOnUpdate(Self);
  if Assigned(FOnComplete) then
    FOnComplete(Self);
end;

procedure TAbstractTween.AddToPlayList(Tween: ITween);
begin
end;

procedure TAbstractTween.RemoveFromPlayList(Tween: ITween);
begin
end;

procedure TAbstractTween.DoOverwrite;
begin
end;

procedure TAbstractTween.SwitchDirection;
begin
  if FDirection = pdForward then
    FDirection := pdBackward
  else
    FDirection := pdForward;
end;

procedure TAbstractTween.Play;
begin
  if FParent <> nil then
    raise ETweenException.Create('łɕʂɃgDC[Ɋ܂܂Ă邽ߒڍĐł܂');

  FIsPaused := False;

  if not FIsInitialized then
    Initialize;

  if not {$IFDEF USECLASSPROPERTY}TTween.{$ENDIF}FList.Contains(Self) then
  begin
    if FOverwrite then
      DoOverwrite;

    {$IFDEF USECLASSPROPERTY}TTween.{$ENDIF}FList.Add(Self);
    AddToPlayList(Self);
  end;
end;

procedure TAbstractTween.Pause;
begin
  if FParent <> nil then
    raise ETweenException.Create('łɕʂɃgDC[Ɋ܂܂Ă邽ߒڈꎞ~ł܂');

  FIsPaused := True;
end;

procedure TAbstractTween.Stop;
begin
  if FParent <> nil then
    raise ETweenException.Create('łɕʂɃgDC[Ɋ܂܂Ă邽ߒڒ~ł܂');

  FIsPaused := True;

  if {$IFDEF USECLASSPROPERTY}TTween.{$ENDIF}FList.Remove(Self) <> -1 then
  begin
    RemoveFromPlayList(Self);
  end;
end;

function TAbstractTween.Clone: ITween;
begin
  Result := ClassType.Create as TAbstractTween;

  with TAbstractTween(Result.Obj) do
  begin
    FPosition := Self.FPosition;
    FDuration := Self.FDuration;
    FDirection := Self.FDirection;
    FParent := nil;
    FIsPaused := Self.FIsPaused;
    FIsCompleted := Self.FIsCompleted;
    FIsInitialized := Self.FIsInitialized;
    FOverwrite := Self.FOverwrite;
    FStopOnComplete := Self.FStopOnComplete;
    FOnUpdate := Self.FOnUpdate;
    FOnComplete := Self.FOnComplete;
  end;
end;

procedure TAbstractTween.Update(const APosition: Double);
begin
  if IsCompleted then Exit;
  if not FIsInitialized then
    Initialize;
  CheckCompleted(APosition);
  DoUpdate;
  if Assigned(FOnUpdate) then
    FOnUpdate(Self);
  if FIsCompleted then
    DoCompleted;
end;

function TAbstractTween.GetObj: TObject;
begin
  Result := Self;
end;

procedure TAbstractTween.SetParent(const Value: TAbstractTween);
begin
  if FParent <> nil then
    raise ETweenException.Create('łɕʂɃgDC[Ɋ܂܂Ă܂');

  Stop;
  FParent := Value;
  StopOnComplete := True;
end;

function TAbstractTween.GetPosition: Double;
begin
  Result := FPosition;
end;

function TAbstractTween.GetDuration: Double;
begin
  Result := FDuration;
end;

function TAbstractTween.GetOverwrite: Boolean;
begin
  Result := FOverwrite;
end;

procedure TAbstractTween.SetOverwrite(const Value: Boolean);
begin
  FOverwrite := Value;
end;

function TAbstractTween.GetStopOnComplete: Boolean;
begin
  Result := FStopOnComplete;
end;

procedure TAbstractTween.SetStopOnComplete(const Value: Boolean);
begin
  FStopOnComplete := Value;
end;

function TAbstractTween.GetIsPaused: Boolean;
begin
  if FParent <> nil then
    Result := FParent.IsPaused
  else
    Result := FIsPaused;
end;

function TAbstractTween.GetIsCompleted: Boolean;
begin
  Result := FIsCompleted;
end;

function TAbstractTween.GetOnUpdate: TTweenEventProc;
begin
  Result := FOnUpdate;
end;

procedure TAbstractTween.SetOnUpdate(const Value: TTweenEventProc);
begin
  FOnUpdate := Value;
end;

function TAbstractTween.GetOnComplete: TTweenEventProc;
begin
  Result := FOnComplete;
end;

procedure TAbstractTween.SetOnComplete(const Value: TTweenEventProc);
begin
  FOnComplete := Value;
end;

{ TObjectTween }

function TObjectTween.GetProperty({$IFDEF USERTTI}const RttiType: TRttiType;{$ENDIF}const Obj: TObject; const PropName: string;
  out IsRelative: Boolean; out PropType: TPropType): PPropInfo;
{$IFDEF USERTTI}
var
  prop: TRttiProperty;
{$ENDIF}
begin
  if Obj = nil then
    raise ETweenException.Create('IuWFNgnilł');

{$IFDEF USERTTI}
  IsRelative := Pos('$', PropName) = 1;
  if IsRelative then
    prop := RttiType.GetProperty(Copy(PropName, 2, Length(PropName)))
  else
    prop := RttiType.GetProperty(PropName);

  if prop = nil then
    raise ETweenException.CreateFmt('w肵vpeB܂ (%s)', [PropName]);

  Result := (prop as TRttiInstanceProperty).PropInfo;
{$ELSE}
  IsRelative := Pos('$', PropName) = 1;
  if IsRelative then
    Result := GetPropInfo(Obj, Copy(PropName, 2, Length(PropName)))
  else
    Result := GetPropInfo(Obj, PropName);

  if Result = nil then
    raise ETweenException.CreateFmt('w肵vpeB܂ (%s)', [PropName]);
{$ENDIF}

  if Result.SetProc = nil then
    raise ETweenException.CreateFmt('w肵vpeB͏݂ł܂ (%s)', [PropName]);

  if Result.GetProc = nil then
    raise ETweenException.CreateFmt('w肵vpeB͓ǂݍ݂ł܂ (%s)', [PropName]);

  case Result.PropType^.Kind of
    tkInteger:
    begin
      if Result.PropType^.Name = 'TColor' then
        PropType := ptColor
      else
        PropType := ptInteger;
    end;
    tkFloat:
    begin
      PropType := ptFloat;
    end;
    tkInt64:
    begin
      PropType := ptInt64;
    end;
    else
      raise ETweenException.CreateFmt('%s ^̃vpeB͖Ήł', [Result.PropType^.Name]);
  end;
end;

// Βl擾
function TObjectTween.GetPropAbsoluteValue(const Obj: TObject;
  const Prop: PPropInfo; const BaseValue: TPropValue): TPropValue;
var
  i: Integer;
  color: Integer;
begin
  case Prop.PropType^.Kind of
    tkInteger:
    begin
      if Prop.PropType^.Name = 'TColor' then
      begin
        color := GetOrdProp(Obj, Prop);
        if BaseValue.AsColor = 0 then
        begin
          Result.AsColor := color;
        end
        else begin
{$IFNDEF FMXAPP}
          if color < 0 then
            color := GetSysColor(color and $000000FF);
{$ENDIF}
          for i := 0 to 2 do
          begin
            LongRec(Result.AsColor).Bytes[i] := Min(LongRec(color).Bytes[i] + LongRec(BaseValue.AsColor).Bytes[i], 255);
          end;
        end;
      end
      else
        Result.AsInteger := GetOrdProp(Obj, Prop) + BaseValue.AsInteger;
    end;
    tkFloat:
    begin
      Result.AsFloat := GetFloatProp(Obj, Prop) + BaseValue.AsFloat;
    end;
    tkInt64:
    begin
      Result.AsInt64 := GetInt64Prop(Obj, Prop) + BaseValue.AsInt64;
    end;
  end;
end;

constructor TObjectTween.Create(const Obj: TObject;
  const FromValues, ToValues: array of const; const Duration: Cardinal;
  const Easing: IEasing);
var
  i, j: Integer;
{$IFDEF USERTTI}
  ctx: TRttiContext;
  typ: TRttiType;
{$ENDIF}

  function TryGetValue(const Prop: PPropInfo; out Value: TPropValue; out IsRelative: Boolean): Boolean;
  var
    i: Integer;
  begin
    for i := 0 to High(FInitValues) do
      if FInitValues[i].Prop = Prop then
      begin
        Value := FInitValues[i].Value;
        IsRelative := FInitValues[i].IsRelative;
        Result := True;
        Exit;
      end;
    Result := False;
  end;

  function IsStringType(const Value: TVarRec): Boolean;
  begin
    Result := (Value.VType = vtString)
           or (Value.VType = vtChar)
           or (Value.VType = vtWideChar)
           or (Value.VType = vtPChar)
           or (Value.VType = vtPWideChar)
           or (Value.VType = vtAnsiString)
           or (Value.VType = vtWideString)
           {$IFDEF USEUNICODE}or (Value.VType = vtUnicodeString){$ENDIF};
  end;

  function GetString(const Value: TVarRec): string;
  begin
    case Value.VType of
      vtString: Result := string(Value.VString^);
      vtChar: Result := string(Value.VChar);
      vtWideChar: Result := string(Value.VWideChar);
      vtPChar: Result := string(Value.VPChar);
      vtPWideChar: Result := string(Value.VPWideChar);
      vtAnsiString: Result := string(AnsiString(Value.VAnsiString));
      vtWideString: Result := string(WideString(Value.VWideString));
{$IFDEF USEUNICODE}
      vtUnicodeString: Result := string(UnicodeString(Value.VUnicodeString));
{$ENDIF}
    end;
  end;

  function GetValue(const Value: TVarRec; const PropType: TPropType): TPropValue;
  begin
    case Value.VType of
      vtInteger:
      begin
        case PropType of
          ptInteger: Result.AsInteger := Value.VInteger;
          ptColor: Result.AsColor := Value.VInteger;
          ptFloat: Result.AsFloat := Value.VInteger;
          ptInt64: Result.AsInt64 := Value.VInteger;
        end;
      end;
      vtExtended:
      begin
        case PropType of
          ptInteger: Result.AsInteger := Trunc(Value.VExtended^);
          ptColor: Result.AsColor := Trunc(Value.VExtended^);
          ptFloat: Result.AsFloat := Value.VExtended^;
          ptInt64: Result.AsInt64 := Trunc(Value.VExtended^);
        end;
      end;
      vtInt64:
      begin
        case PropType of
          ptInteger: Result.AsInteger := Value.VInt64^;
          ptColor: Result.AsColor := Value.VInt64^;
          ptFloat: Result.AsFloat := Value.VInt64^;
          ptInt64: Result.AsInt64 := Value.VInt64^;
        end;
      end;
    end;
  end;

begin
  inherited Create;

  if Duration = 0 then
    raise ETweenException.Create('Durationɂ̓[傫lw肵ĉ');

  if Odd(Length(FromValues)) then
    raise ETweenException.Create('FromValuesɂ̓vpeBƒl̃yAw肵ĉ');

  if Odd(Length(ToValues)) then
    raise ETweenException.Create('ToValuesɂ̓vpeBƒl̃yAw肵ĉ');

  if (Length(FromValues) = 0) and (Length(ToValues) = 0) then
    raise ETweenException.Create('FromValuesToValues̗A邢͂ꂩЕ1ȏ̃vpeBƒl̃yAw肵ĉ');

  // Ƀ`FbNႤ
  i := 0;
  while i < Length(FromValues) do
  begin
    if not IsStringType(FromValues[i]) then
      raise ETweenException.CreateFmt('FromValues%dԖڂ̈ɂ͕^̒lw肵ĉ', [i]);
    if not (FromValues[i+1].VType in [vtInteger, vtExtended, vtInt64]) then
      raise ETweenException.CreateFmt('FromValues%dԖڂ̈ɂ͐^A܂͎^̒lw肵ĉ', [i+1]);
    Inc(i, 2);
  end;

  i := 0;
  while i < Length(ToValues) do
  begin
    if not IsStringType(ToValues[i]) then
      raise ETweenException.CreateFmt('ToValues%dԖڂ̈ɂ͕^̒lw肵ĉ', [i]);
    if not (ToValues[i+1].VType in [vtInteger, vtExtended, vtInt64]) then
      raise ETweenException.CreateFmt('ToValues%dԖڂ̈ɂ͐^A܂͎^̒lw肵ĉ', [i+1]);
    Inc(i, 2);
  end;

{$IFDEF USERTTI}
  ctx := TRttiContext.Create;
  typ := ctx.GetType(Obj.ClassType);
  if typ = nil then
    raise ETweenException.CreateFmt('%s ̌^擾ł܂', [Obj.ClassName]);
{$ENDIF}

  FIsValueFixed := False;

  i := 0; j := 0;

  // FromValuesw肳ĂȂꍇToValues̃vpeB̌ݒlݒ
  if Length(FromValues) = 0 then
  begin
    SetLength(FInitValues, Length(ToValues) div 2);
    while i < Length(ToValues) do
    begin
      with FInitValues[j] do
      begin
        Prop := GetProperty({$IFDEF USERTTI}typ,{$ENDIF}Obj, GetString(ToValues[i]), IsRelative, PropType);
        IsRelative := True;
        FillChar(Value, SizeOf(Value), 0);
      end;
      Inc(i, 2);
      Inc(j);
    end;
  end
  else begin
    SetLength(FInitValues, Length(FromValues) div 2);
    while i < Length(FromValues) do
    begin
      with FInitValues[j] do
      begin
        Prop := GetProperty({$IFDEF USERTTI}typ,{$ENDIF}Obj, GetString(FromValues[i]), IsRelative, PropType);
        Value := GetValue(FromValues[i+1], PropType);
      end;
      Inc(i, 2);
      Inc(j);
    end;
  end;

  i := 0; j := 0;

  // ToValuesw肳ĂȂꍇFromValues̃vpeB̌ݒlݒ
  if Length(ToValues) = 0 then
  begin
    SetLength(FChangeValues, Length(FromValues) div 2);
    while i < Length(FromValues) do
    begin
      with FChangeValues[j] do
      begin
        Prop := GetProperty({$IFDEF USERTTI}typ,{$ENDIF}Obj, GetString(FromValues[i]), IsRelative, PropType);
        IsRelative := True;
        BaseValue := GetValue(FromValues[i+1], PropType);
        FillChar(FinishValue, SizeOf(FinishValue), 0);
      end;
      Inc(i, 2);
      Inc(j)
    end;
  end
  else begin
    SetLength(FChangeValues, Length(ToValues) div 2);
    while i < Length(ToValues) do
    begin
      with FChangeValues[j] do
      begin
        Prop := GetProperty({$IFDEF USERTTI}typ,{$ENDIF}Obj, GetString(ToValues[i]), IsRelative, PropType);
        FinishValue := GetValue(ToValues[i+1], PropType);
      end;
      Inc(i, 2);
      Inc(j);
    end;
  end;

  FObj := Obj;
  FDuration := Duration;
  if Assigned(Easing) then
    FEasing := Easing
  else
    FEasing := TEasing.Linear;
end;

{ Βl̎s擾ƍvZ }
procedure TObjectTween.CalcValues;
var
  i, j: Integer;
  color: Integer;

  function TryGetInitValue(const Prop: PPropInfo; out Value: TPropValue): Boolean;
  var
    i: Integer;
  begin
    for i := 0 to High(FInitValues) do
      if FInitValues[i].Prop = Prop then
      begin
        Value := FInitValues[i].Value;
        Result := True;
        Exit;
      end;
    Result := False;
  end;

begin
  for i := Low(FInitValues) to High(FInitValues) do
  begin
    with FInitValues[i] do
      if IsRelative then
        Value := GetPropAbsoluteValue(FObj, Prop, Value);
  end;

  for i := Low(FChangeValues) to High(FChangeValues) do
  begin
    with FChangeValues[i] do
    begin
      if not TryGetInitValue(Prop, BaseValue) then
      begin
        case PropType of
          ptInteger: BaseValue.AsInteger := GetOrdProp(FObj, Prop);
          ptColor: BaseValue.AsColor := GetOrdProp(FObj, Prop);
          ptFloat: BaseValue.AsFloat := GetFloatProp(FObj, Prop);
          ptInt64: BaseValue.AsInt64 := GetInt64Prop(FObj, Prop);
        end;
      end;

      if IsRelative then
        FinishValue := GetPropAbsoluteValue(FObj, Prop, FinishValue);

      // vZ
      case PropType of
        ptInteger: DiffValue.AsInteger := FinishValue.AsInteger - BaseValue.AsInteger;
        ptColor:
        begin
{$IFNDEF FMXAPP}
          if BaseValue.AsColor < 0 then
            BaseValue.AsColor := GetSysColor(BaseValue.AsColor and $000000FF);
{$ENDIF}
          color := FinishValue.AsColor;
{$IFNDEF FMXAPP}
          if color < 0 then
            color := GetSysColor(color and $000000FF);
{$ENDIF}
          for j := 0 to 2 do
            DiffValue.AsColor[j] := LongRec(color).Bytes[j] - LongRec(BaseValue.AsColor).Bytes[j];
        end;
        ptFloat:
        begin
          DiffValue.AsFloat := FinishValue.AsFloat - BaseValue.AsFloat;
        end;
        ptInt64:
        begin
          DiffValue.AsInt64 := FinishValue.AsInt64 - BaseValue.AsInt64;
        end;
      end;
    end;
  end;

  FIsValueFixed := True;
end;

function TObjectTween.Clone: ITween;
begin
  Result := inherited;
  with TObjectTween(Result.Obj) do
  begin
    FObj := Self.FObj;
    FEasing := Self.FEasing;
    FIsValueFixed := Self.FIsValueFixed;
    FInitValues := Copy(Self.FInitValues);
    FChangeValues := Copy(Self.FChangeValues);
  end;
end;

procedure TObjectTween.AddToPlayList(Tween: ITween);
begin
  TTween.AddToPlayList(FObj, Tween);
end;

procedure TObjectTween.RemoveFromPlayList(Tween: ITween);
begin
  TTween.RemoveFromPlayList(FObj, Tween);
end;

procedure TObjectTween.DoOverwrite;
begin
  TTween.Abort(FObj);
end;

procedure TObjectTween.ApplyPropValue(const PropType: TPropType;
  const PropInfo: PPropInfo; const PropValue: TPropValue);
begin
  case PropType of
    ptInteger: SetOrdProp(FObj, PropInfo, PropValue.AsInteger);
    ptColor: SetOrdProp(FObj, PropInfo, PropValue.AsColor);
    ptFloat: SetFloatProp(FObj, PropInfo, PropValue.AsFloat);
    ptInt64: SetInt64Prop(FObj, PropInfo, PropValue.AsInt64);
  end;
end;

procedure TObjectTween.Initialize;
var
  i: Integer;
begin
  inherited;

  if not FIsValueFixed then
    CalcValues;

  if FDirection = pdForward then
  begin
    for i := 0 to High(FInitValues) do
      with FInitValues[i] do
        ApplyPropValue(PropType, Prop, Value);
  end
  else begin
    for i := 0 to High(FChangeValues) do
      with FChangeValues[i] do
        ApplyPropValue(PropType, Prop, FinishValue);
  end;
end;

procedure TObjectTween.Finalize;
var
  i: Integer;
begin
  if FDirection = pdForward then
  begin
    for i := 0 to High(FChangeValues) do
      with FChangeValues[i] do
        ApplyPropValue(PropType, Prop, FinishValue);
  end
  else begin
    for i := 0 to High(FInitValues) do
      with FInitValues[i] do
        ApplyPropValue(PropType, Prop, Value);
  end
end;

procedure TObjectTween.DoUpdate;

  function RoundOff(const Value: Double): Int64; {$IFDEF USEINLINE}inline;{$ENDIF}
  begin
    if Value >= 0 then Result := Trunc(Value + 0.5)
    else Result := Trunc(Value - 0.5);
  end;

var
  i, j: Integer;
  value: Integer;
begin
  for i := 0 to High(FChangeValues) do
  begin
    with FChangeValues[i] do
    begin
      case PropType of
        ptInteger: SetOrdProp(FObj, Prop, RoundOff(FEasing.Calculate(FPosition, BaseValue.AsInteger, DiffValue.AsInteger, FDuration)));
        ptColor:
        begin
          value := 0;
          for j := 0 to 2 do
            LongRec(value).Bytes[j] := RoundOff(FEasing.Calculate(FPosition, Longrec(BaseValue.AsColor).Bytes[j], DiffValue.AsColor[j], FDuration));
          SetOrdProp(FObj, Prop, value);
        end;
        ptFloat: SetFloatProp(FObj, Prop, FEasing.Calculate(FPosition, BaseValue.AsFloat, DiffValue.AsFloat, FDuration));
        ptInt64: SetInt64Prop(FObj, Prop, RoundOff(FEasing.Calculate(FPosition, BaseValue.AsInt64, DiffValue.AsInt64, FDuration)));
      end;
    end;
  end;
end;

{ TGroupTween }

constructor TWrapTween.Create(const Tweens: array of ITween);
var
  i: Integer;
  t: TAbstractTween;
begin
  if Length(Tweens) = 0 then
    raise ETweenException.Create('1ȏITweenw肵ĉ');

  inherited Create;

  FDuration := 0;
  SetLength(FTweens, Length(Tweens));
  for i := Low(FTweens) to High(FTweens) do
  begin
    if Tweens[i] = nil then
      raise ETweenException.CreateFmt('nil͎wł܂ (Tweens[%d] = nil)', [i]);

    t := TAbstractTween(Tweens[i].Obj);
    if t.Parent <> nil then
    begin
      FTweens[i] := t.Clone;
      t := TAbstractTween(FTweens[i].Obj);
      if t.FDirection = pdBackward then
        t.SwitchDirection;
    end
    else begin
      FTweens[i] := Tweens[i];
    end;
    t.Parent := Self;
  end;
end;

constructor TWrapTween.Create(const BaseTween: ITween);
begin
  Create([BaseTween]);
end;

function TWrapTween.Clone: ITween;
var
  i: Integer;
begin
  Result := inherited;
  with TWrapTween(Result.Obj) do
  begin
    SetLength(FTweens, Length(Self.FTweens));
    for i := Low(Self.FTweens) to High(Self.FTweens) do
      FTweens[i] := Self.FTweens[i].Clone;
  end;
end;

procedure TWrapTween.AddToPlayList(Tween: ITween);
var
  i: Integer;
begin
  for i := Low(FTweens) to High(FTweens) do
    TAbstractTween(FTweens[i].Obj).AddToPlayList(Tween);
end;

procedure TWrapTween.RemoveFromPlayList(Tween: ITween);
var
  i: Integer;
begin
  for i := Low(FTweens) to High(FTweens) do
    TAbstractTween(FTweens[i].Obj).RemoveFromPlayList(Tween);
end;

procedure TWrapTween.DoOverwrite;
var
  i: Integer;
begin
  for i := Low(FTweens) to High(FTweens) do
    TAbstractTween(FTweens[i].Obj).DoOverwrite;
end;

procedure TWrapTween.SwitchDirection;
var
  i: Integer;
begin
  inherited;
  for i := Low(FTweens) to High(FTweens) do
    TAbstractTween(FTweens[i].Obj).SwitchDirection;
end;

function TWrapTween.GetBaseTween: ITween;
begin
  Result := FTweens[0];
end;

{ TParallelTween }

constructor TParallelTween.Create(const Tweens: array of ITween);
var
  i: Integer;
begin
  inherited;
  for i := Low(FTweens) to High(FTweens) do
    if FTweens[i].Duration > FDuration then
      FDuration := FTweens[i].Duration;
end;

procedure TParallelTween.Initialize;
var
  i: Integer;
begin
  inherited;
  for i := Low(FTweens) to High(FTweens) do
    TAbstractTween(FTweens[i].Obj).Initialize;
end;

procedure TParallelTween.DoUpdate;
var
  i: Integer;
  t: TAbstractTween;
begin
  if FDirection = pdForward then
  begin
    for i := Low(FTweens) to High(FTweens) do
      TAbstractTween(FTweens[i].Obj).Update(FPosition);
  end
  else begin
    for i := Low(FTweens) to High(FTweens) do
    begin
      t := TAbstractTween(FTweens[i].Obj);
      if FPosition <= t.Duration then
        t.Update(FPosition);
    end;
  end;
end;

{ TSerialTween }

constructor TSerialTween.Create(const Tweens: array of ITween);
var
  i: Integer;
begin
  inherited;
  for i := Low(FTweens) to High(FTweens) do
    FDuration := FDuration + FTweens[i].Duration;
end;

function TSerialTween.Clone: ITween;
begin
  Result := inherited;
  with TSerialTween(Result.Obj) do
  begin
    FTweenIndex := Self.FTweenIndex;
    FDurationOffset := Self.FDurationOffset;
  end;
end;

procedure TSerialTween.Initialize;
var
  i: Integer;
begin
  inherited;
  if FDirection = pdForward then
  begin
    FDurationOffset := 0;
    FTweenIndex := 0;
  end
  else begin
    FDurationOffset := 0;
    for i := 0 to High(FTweens)-1 do
      FDurationOffset := FDurationOffset + FTweens[i].Duration;
    FTweenIndex := High(FTweens);
  end;
  if Length(FTweens) <> 0 then
    TAbstractTween(FTweens[FTweenIndex].Obj).Initialize;
end;

procedure TSerialTween.DoUpdate;
begin
  if (FTweenIndex < Low(FTweens)) or (FTweenIndex > High(FTweens)) then Exit;

  if FPosition - FDurationOffset < 0 then
    TAbstractTween(FTweens[FTweenIndex].Obj).Update(0)
  else
    TAbstractTween(FTweens[FTweenIndex].Obj).Update(FPosition - FDurationOffset);

  while FTweens[FTweenIndex].IsCompleted do
  begin
    if FDirection = pdForward then
    begin
      if FTweenIndex+1 > High(FTweens) then
      begin
        FIsCompleted := True;
        FPosition := FDuration;
        Break;
      end;
      FDurationOffset := FDurationOffset + FTweens[FTweenIndex].Duration;
      Inc(FTweenIndex);

      TAbstractTween(FTweens[FTweenIndex].Obj).Initialize; // [t1, t1]ƓTweenw肳ꂽꍇpɕK{
      if FPosition - FDurationOffset <= 0 then Break;
      TAbstractTween(FTweens[FTweenIndex].Obj).Update(FPosition - FDurationOffset);
    end
    else begin
      if FTweenIndex-1 < Low(FTweens) then
      begin
        FIsCompleted := True;
        FPosition := 0;
        Break;
      end;
      Dec(FTweenIndex);
      FDurationOffset := FDurationOffset - FTweens[FTweenIndex].Duration;

      TAbstractTween(FTweens[FTweenIndex].Obj).Initialize; // [t1, t1]ƓTweenw肳ꂽꍇpɕK{
      TAbstractTween(FTweens[FTweenIndex].Obj).Update(FPosition - FDurationOffset);
    end;
  end;
end;

{ TDelayedTween }

constructor TDelayedTween.Create(const PreDelay, PostDelay: Cardinal; const BaseTween: ITween);
begin
  if BaseTween = nil then
    raise ETweenException.Create('fBCΏۂITweenɂnilwł܂');

  inherited Create(BaseTween);

  FPreDelay := PreDelay;
  FPostDelay := PostDelay;
  FDuration := FPreDelay + BaseTween.Duration + FPostDelay;
end;

function TDelayedTween.Clone: ITween;
begin
  Result := inherited;
  with TDelayedTween(Result.Obj) do
  begin
    FPreDelay := Self.FPreDelay;
    FPostDelay := Self.FPostDelay;
  end;
end;

procedure TDelayedTween.DoUpdate;
var
  tween: TAbstractTween;
begin
  tween := TAbstractTween(BaseTween.Obj);
  if (not IsCompleted) and (FPosition > FPreDelay) and (FPosition <= FDuration - FPostDelay) then
  begin
    tween.Update(FPosition - FPreDelay);
  end;
end;

{ TCycledTween }

constructor TCycledTween.Create(const CycleCount: Cardinal;
  const BaseTween: ITween);
begin
  if BaseTween = nil then
    raise ETweenException.Create('fBCΏۂITweenɂnilwł܂');

  inherited Create(BaseTween);

  FCurrentCount := 0;
  FCycleCount := CycleCount;
  FDuration := BaseTween.Duration * FCycleCount;
end;

function TCycledTween.Clone: ITween;
begin
  Result := inherited;
  with TCycledTween(Result.Obj) do
  begin
    FCurrentCount := Self.FCurrentCount;
    FCycleCount := Self.FCycleCount;
  end;
end;

procedure TCycledTween.Initialize;
begin
  inherited;
  if FDirection = pdForward then
  begin
    FCurrentCount := 0;
  end
  else begin
    FCurrentCount := FCycleCount-1;
  end;
  TAbstractTween(BaseTween.Obj).Initialize;
end;

procedure TCycledTween.DoUpdate;
begin
  TAbstractTween(BaseTween.Obj).Update(FPosition - BaseTween.Duration * FCurrentCount);
  while BaseTween.IsCompleted do
  begin
    if FDirection = pdForward then
    begin
      Inc(FCurrentCount);
      if FCurrentCount >= FCycleCount then
      begin
        FIsCompleted := True;
        FPosition := FDuration;
        Break;
      end;

      TAbstractTween(BaseTween.Obj).Initialize;
      TAbstractTween(BaseTween.Obj).Update(FPosition - BaseTween.Duration * FCurrentCount);
    end
    else begin
      if FCurrentCount <= 0 then
      begin
        FIsCompleted := True;
        FPosition := 0;
        Break;
      end;
      Dec(FCurrentCount);

      TAbstractTween(BaseTween.Obj).Initialize;
      TAbstractTween(BaseTween.Obj).Update(FPosition - BaseTween.Duration * FCurrentCount);
    end;
  end;
end;

{ TReversedTween }

constructor TReversedTween.Create(const BaseTween: ITween);
begin
  if BaseTween = nil then
    raise ETweenException.Create('tĐΏۂITweenɂnilwł܂');

  inherited Create(BaseTween);
  FDuration := BaseTween.Duration;
  TAbstractTween(BaseTween.Obj).SwitchDirection;
end;

procedure TReversedTween.Initialize;
begin
  inherited;
  TAbstractTween(BaseTween.Obj).Initialize;
end;

procedure TReversedTween.DoUpdate;
begin
  TAbstractTween(BaseTween.Obj).Update(FDuration - FPosition);
end;

{ TScaledTween }

constructor TScaledTween.Create(const Scale: Double; const BaseTween: ITween);
begin
  if BaseTween = nil then
    raise ETweenException.Create('XP[ΏۂITweenɂnilwł܂');
  if Scale <= 0 then
    raise ETweenException.CreateFmt('XP[lɂ0傫lw肵ĉ (%f)', [Scale]);

  inherited Create(BaseTween);
  FScale := Scale;
  FDuration := BaseTween.Duration * FScale;
end;

function TScaledTween.Clone: ITween;
begin
  Result := inherited;
  with TScaledTween(Result.Obj) do
  begin
    FScale := Self.FScale;
  end;
end;

procedure TScaledTween.Initialize;
begin
  inherited;
  TAbstractTween(BaseTween.Obj).Initialize;
end;

procedure TScaledTween.DoUpdate;
begin
  TAbstractTween(BaseTween.Obj).Update(FPosition / FScale);
end;

{ TSlicedTween }

constructor TSlicedTween.Create(const StartPos, EndPos: Double;
  const BaseTween: ITween);
begin
  if BaseTween = nil then
    raise ETweenException.Create('XCXΏۂITweenɂnilwł܂');
  if StartPos < 0 then
    raise ETweenException.CreateFmt('Jnʒu0ȏ̒lw肵ĉ (%f)', [StartPos]);
  if (EndPos > BaseTween.Duration) then
    raise ETweenException.CreateFmt('Iʒu%fȉ̒lw肵ĉ (%f)', [BaseTween.Duration, EndPos]);
  if StartPos >= EndPos then
    raise ETweenException.CreateFmt('Jnʒu͏Iʒu菬Ȓlw肵ĉ (Start=%f, End=%f)', [StartPos, EndPos]);

  inherited Create(BaseTween);
  FStartPos := StartPos;
  FEndPos := EndPos;
  FDuration := FEndPos - FStartPos;
end;

function TSlicedTween.Clone: ITween;
begin
  Result := inherited;
  with TSlicedTween(Result.Obj) do
  begin
    FStartPos := Self.FStartPos;
    FEndPos := Self.FEndPos;
  end;
end;

procedure TSlicedTween.Initialize;
var
  t: TAbstractTween;
begin
  inherited;
  t := TAbstractTween(BaseTween.Obj);
  t.Initialize;
  if FDirection = pdForward then
  begin
    t.Update(FStartPos);
  end
  else begin
    t.Update(FEndPos);
  end;
end;

procedure TSlicedTween.DoUpdate;
var
  tween: TAbstractTween;
begin
  tween := TAbstractTween(BaseTween.Obj);
  if FDirection = pdForward then
  begin
    if not FIsCompleted then
      tween.Update(FStartPos+FPosition)
    else
      tween.Update(FEndPos);
  end
  else begin
    if not FisCompleted then
      tween.Update(FStartPos+FPosition)
    else
      tween.Update(FStartPos);
  end;
end;

{ TTween }

class procedure TTween.ListNotify(Sender: TObject; const Item: ITween;
  Action: TCollectionNotification);
begin
  case Action of
    cnAdded:
    begin
      if FList.Count = 1 then
        StartTimer;
    end;
    cnRemoved, cnExtracted:
    begin
      if FList.Count = 0 then
        ClearTimer;
    end;
  end;
end;

class procedure TTween.OnTimer(Sender: TObject);
begin
  TTween.Update;
end;

class procedure TTween.StartTimer;
begin
  if not FAutoUpdate then Exit;
  ClearTimer;
  if FList.Count = 0 then Exit;
  FPrevTime := GetTick;
  FTimer.Interval := 1000 div FSpeed;
  FTimer.Enabled := True;
end;

class procedure TTween.ClearTimer;
begin
  FTimer.Enabled := False;
end;

class procedure TTween.Abort(Obj: TObject = nil);
var
  i: Integer;
  list: TTweenList;
begin
  if Obj = nil then
  begin
    while FList.Count > 0 do
      FList[0].Stop;
  end
  else begin
    if FObjTweens.TryGetValue(Obj, list) then
    begin
      for i := 0 to list.Count-1 do
      begin
        TAbstractTween(list[i].Obj).Stop;
      end;
      FObjTweens.Remove(Obj);
    end;
  end;
end;

class procedure TTween.AddToPlayList(Obj: TObject; Tween: ITween);
var
  list: TTweenList;
begin
  if not FObjTweens.ContainsKey(Obj) then
  begin
    list := TTweenList.Create;
    list.Add(Tween);
    FObjTweens.Add(Obj, list);
  end
  else begin
    list := FObjTweens[Obj];
    if not list.Contains(Tween) then
      list.Add(Tween);
  end;
end;

class procedure TTween.RemoveFromPlayList(Obj: TObject; Tween: ITween);
var
  list: TTweenList;
begin
  if not FObjTweens.TryGetValue(Obj, list) then Exit;
  if list.Remove(Tween) = -1 then Exit;
  if list.Count <> 0 then Exit;
  FObjTweens.Remove(Obj);
end;

class procedure TTween.Update;
var
  i: Integer;
  curTime: Cardinal;
  delta: Cardinal;
  tween: TAbstractTween;
begin
  if Assigned(FOnBeforeUpdate) then
    FOnBeforeUpdate;

  i := 0;
  curTime := GetTick;
  delta := curTime - FPrevTime;
  while i < FList.Count do
  begin
    tween := TAbstractTween(FList[i].Obj);
    if (not tween.IsCompleted) and (not tween.IsPaused) then
    begin
      tween.Update(tween.Position + delta);
      if tween.IsCompleted then
      begin
        if tween.StopOnComplete then
        begin
          tween.Stop;
        end
        else begin
          tween.Initialize;
          Inc(i);
        end;
      end
      else begin
        Inc(i);
      end;
    end
    else begin
      Inc(i);
    end;
  end;
  FPrevTime := curTime;

  if Assigned(FOnAfterUpdate) then
    FOnAfterUpdate;
end;

type
  TTweenArray = array of ITween;

  TArrayHelper = class
  public
    class procedure Add(var Values: TTweenArray; const Item: ITween);
  end;

class procedure TArrayHelper.Add(var Values: TTweenArray; const Item: ITween);
begin
  SetLength(Values, Length(Values)+1);
  Values[High(Values)] := Item;
end;

class function TTween.Tween(const Obj: TObject; const FromValues, ToValues: array of const;
  const Duration: Cardinal; const Easing: IEasing): ITween;
begin
  Result := TObjectTween.Create(Obj, FromValues, ToValues, Duration, Easing);
end;

class function TTween.Tween(const Objs: array of TObject; const FromValues,
  ToValues: array of const; const Duration: Cardinal;
  const Easing: IEasing): ITween;
var
  i: Integer;
  tweens: TTweenArray;
begin
  for i := Low(Objs) to High(Objs) do
  begin
    TArrayHelper.Add(tweens, TTween.Tween(Objs[i], FromValues, ToValues, Duration, Easing));
  end;
  Result := TParallelTween.Create(tweens);
end;

class function TTween.TweenTo(Obj: TObject; const ToValues: array of const;
  Duration: Cardinal; const Easing: IEasing): ITween;
begin
  Result := Tween(Obj, [], ToValues, Duration, Easing);
end;

class function TTween.TweenTo(const Objs: array of TObject;
  const ToValues: array of const; Duration: Cardinal;
  const Easing: IEasing): ITween;
begin
  Result := Tween(Objs, [], ToValues, Duration, Easing);
end;

class function TTween.TweenFrom(Obj: TObject; const FromValues: array of const;
  Duration: Cardinal; const Easing: IEasing): ITween;
begin
  Result := Tween(Obj, FromValues, [], Duration, Easing);
end;

class function TTween.TweenFrom(const Objs: array of TObject;
  const FromValues: array of const; Duration: Cardinal;
  const Easing: IEasing): ITween;
begin
  Result := Tween(Objs, FromValues, [], Duration, Easing);
end;

class function TTween.Parallel(const Tweens: array of ITween): ITween;
begin
  Result := TParallelTween.Create(Tweens);
end;

class function TTween.Serial(const Tweens: array of ITween): ITween;
begin
  Result := TSerialTween.Create(Tweens);
end;

class function TTween.Delay(const PreDelay, PostDelay: Cardinal;
  const BaseTween: ITween): ITween;
begin
  Result := TDelayedTween.Create(PreDelay, PostDelay, BaseTween);
end;

class function TTween.Cycle(const CycleCount: Cardinal;
  const BaseTween: ITween): ITween;
begin
  Result := TCycledTween.Create(CycleCount, BaseTween);
end;

class function TTween.Reverse(const BaseTween: ITween): ITween;
begin
  Result := TReversedTween.Create(BaseTween);
end;

class function TTween.Scale(const Scale: Double;
  const BaseTween: ITween): ITween;
begin
  Result := TScaledTween.Create(Scale, BaseTween);
end;

class function TTween.Slice(const StartPos, EndPos: Double;
  const BaseTween: ITween; const IsRate: Boolean = False): ITween;
var
  s, e: Double;
begin
  if IsRate then
  begin
    if (StartPos < 0) or (EndPos > 1) then
      raise ETweenException.CreateFmt(
        'IsRate=True̎0.0`1.0͈̔͂Ŏw肵ĉ (StartPos=%.2f, EndPos=%.2f)', [StartPos, EndPos]);

    s := BaseTween.Duration * StartPos;
    e := BaseTween.Duration * EndPos;
  end
  else begin
    s := StartPos;
    e := EndPos;
  end;
  if s > e then
    Result := TReversedTween.Create(TSlicedTween.Create(s, e, BaseTween))
  else
    Result := TSlicedTween.Create(s, e, BaseTween);
end;

{$IFDEF USECLASSPROPERTY}
class procedure TTween.SetAutoUpdate(const Value: Boolean);
begin
  if FAutoUpdate = Value then Exit;
  FAutoUpdate := Value;
  if FAutoUpdate then
  begin
    TTween.StartTimer;
  end
  else begin
    TTween.ClearTimer;
  end;
end;

class procedure TTween.SetSpeed(const Value: Cardinal);
begin
  if FSpeed = Value then Exit;
  if (Value < 1) or (Value > 1000) then
    raise ETweenException.CreateFmt('Speed1`1000͈̔͂Ŏw肵ĉ (%d)', [Value]);
  FSpeed := Value;
  if not FAutoUpdate then Exit;
  StartTimer;
end;
{$ENDIF}

initialization
{$IFDEF USECLASSPROPERTY}with TTween do begin{$ENDIF}
  FList := TTweenList.Create;
  FList.OnNotify := TTween.ListNotify;
  FObjTweens := TObjectTweenDictionary.Create;
  FDefaultOverwrite := True;
  FAutoUpdate := True;
  FSpeed := DEFAULT_SPEED;
  FTimer := TTimer.Create(nil);
  FTimer.Enabled := False;
  FTimer.OnTimer := TTween.OnTimer;
{$IFDEF USECLASSPROPERTY}end;{$ENDIF}
finalization
  TTween.ClearTimer;
{$IFDEF USECLASSPROPERTY}with TTween do begin{$ENDIF}
  FObjTweens.Free;
  FList.Free;
  FTimer.Free;
{$IFDEF USECLASSPROPERTY}end;{$ENDIF}
end.
